; 
    include \masm32\include\masm32rt.inc
    include \masm32\macros\ucmacros.asm
; 
    .data
      hDir          dd 0
      bytesReturned dd 0
      pBuffer       dd 0
      szCurDir      db MAX_PATH dup(0)
    .code
; 
start:
; 

    invoke GetCurrentDirectory, MAX_PATH, ADDR szCurDir

    invoke CreateFile, ADDR szCurDir,
                       GENERIC_READ,
                       FILE_SHARE_READ+FILE_SHARE_WRITE+FILE_SHARE_DELETE,
                       NULL,
                       OPEN_EXISTING,
                       FILE_FLAG_BACKUP_SEMANTICS+FILE_FLAG_NO_BUFFERING,
                       NULL
    mov hDir, eax

  readLoop:

    invoke ReadDirectoryChangesW, hDir,
                                  ADDR pBuffer,
                                  1024,
                                  FALSE,
                                  FILE_NOTIFY_CHANGE_SIZE,
                                  ADDR bytesReturned,
                                  NULL,
                                  NULL
    .IF eax == 0
      print "ReadDirectoryChangesW failed",13,10
      jmp fail
    .ENDIF  
    
    lea ebx, pBuffer
  @@:
    ; --------------------------------------
    ; The file name length is in bytes and
    ; the file name is NOT null terminated.
    ; --------------------------------------
    mov ecx, [ebx].FILE_NOTIFY_INFORMATION.FileNameLength
    shr ecx, 1
    mov eax, ebx
    add eax, FILE_NOTIFY_INFORMATION.FileName
    invoke crt_wcsncmp, eax, uni$("test.log"), ecx

    .IF eax == 0
      print ustr$(rv(filesize,chr$("test.log"))),13,10
    .ELSE
      .IF [ebx].FILE_NOTIFY_INFORMATION.NextEntryOffset
        print "*"
        add ebx, [ebx].FILE_NOTIFY_INFORMATION.NextEntryOffset
        jmp @B
      .ENDIF
    .ENDIF

    jmp readLoop

  fail:

    inkey "Press any key to exit..."
    exit

; 

end start

FILE_NOTIFY_INFORMATION STRUCT
    NextEntryOffset dd  ?
    Action dd           ?
    FileNameLength dd   ?
    FileName dw         ?
FILE_NOTIFY_INFORMATION ENDS
